/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef ASYNC_P2P_TRACE_EVENT_H
#define ASYNC_P2P_TRACE_EVENT_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <otf2/otf2.h>
#include "RequestP2PTraceEvent.h"
#include "TraceEventGroup.h"



class AsyncP2PTraceEvent : public RequestP2PTraceEvent 
{
    
protected:
    P2PTraceEvent * waiting_event;
    
    
public:

    AsyncP2PTraceEvent(  uint64_t _location): RequestP2PTraceEvent( _location)
    { 
        waiting_event = NULL; 
    };
    
    virtual
    ~AsyncP2PTraceEvent() {};
    
    
    inline
    void
    init( uint64_t _t, uint64_t _p2p_partner, uint64_t _c, uint64_t _r)
    {
        set_request( _r );
        P2PTraceEvent::init( _t, _p2p_partner, _c );
    }

    inline 
    void
    set_waiting_event( P2PTraceEvent * _w)
    {
        waiting_event = _w;
    }
    
    inline 
    P2PTraceEvent *
    get_waiting_event() const
    {
        return waiting_event;
    }
    
    inline 
    void
    set_events_group( TraceEventGroup *_c)
    {
        events_group = _c;
    }
     
    
    
};



#endif // TRACE_EVENT_H

