/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __BINARY_EVALUATION_H
#define __BINARY_EVALUATION_H 0

#include "GeneralEvaluation.h"


// namespace cube
// {
class BinaryEvaluation : public GeneralEvaluation
{
protected:

    GeneralEvaluation * argument1;
    GeneralEvaluation * argument2;


public:
    BinaryEvaluation();
    BinaryEvaluation( GeneralEvaluation*,
                      GeneralEvaluation* );
    virtual
    ~BinaryEvaluation();
    
    inline
    virtual
    void
    set_verbose_execution( bool _v )
    {
        verbose_execution = _v;
        argument1->set_verbose_execution( _v );
        argument2->set_verbose_execution( _v );
    }
    
    
    virtual
    void
    setArguments( GeneralEvaluation*, GeneralEvaluation*);
    
    
    
};
// };

#endif
