/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef BLADE_PLUGIN_WIDGET_H
#define BLADE_PLUGIN_WIDGET_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QToolBar>
#include <QStackedWidget>

#include "Cube.h"
#include "TabInterface.h"

#include "LoadTraceWidget.h"
#include "BladeWidget.h"
#include "BladeToolBar.h"

class BladePluginWidget : public QWidget
{
    Q_OBJECT
    
private:
    LoadTraceWidget * load_trace_widget;
    BladeWidget * blade_widget;
    QStackedWidget * _stacked_widget;
    cube::Cube*    cube;
    BladeToolBar * toolBar;
    
private slots:
    void
    showTrace();
    
public:
    BladePluginWidget(QString, cube::Cube*, BladeToolBar*, QWidget * parent = NULL);
    
    
    void
    tabActivated( cubepluginapi::TreeType  type );
    
    void
    selectionChanged( cube::Metric*, bool, 
                      cube::Cnode*, bool,  
                      cube::Sysres*, bool,  
                      cube::Region*, bool );
};

#endif // TESTPLUGIN1_H
