/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef BLADE_TOOLBAR_H
#define BLADE_TOOLBAR_H

#include <QToolButton>
#include <QLineEdit>
#include <QComboBox>
#include <QToolBar>
#include <QToolButton>
#include <QLabel>


#include "BladeWidget.h"

class TreeItem;
class PluginServices;

class BladeToolBar : public QToolBar
{
    Q_OBJECT
public:
    BladeToolBar( cubepluginapi::PluginServices* service );
    
    
    void
    setBladeWidget( BladeWidget* newparent );

    void
    reinit();
    
    void
    showSelf();
    
    void
    hideSelf();
    
private slots:

    void
    info();
    void
    goBack();
    void
    unZoom();
    void
    moveRight();
    void
    moveLeft();
    void
    compactToggle();
    void
    selectCollective(bool);
    void
    selectPoint2Point(bool);
    void
    selectOthers(bool);
    void
    setRegionFilterName( const QString &);

private:
    cubepluginapi::PluginServices*       service;
    BladeWidget* parent;
    QAction  *info_action, *back_action, 
	     *left_action, *unzoom_action, 
	     *right_action, *roles_filter_action, 
	     *compact_action;
    QLineEdit * filter_input;
    
    bool active;
};
#endif
