/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2017                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef BLADE_UTILS_H
#define BLADE_UTILS_H
#include <QString>
#include <string>
class TreeItem;
class PluginServices;

class BladeUtils 
{
private:
    static 
    const int
    maxRegionName = 80;
    
    static 
    const 
    int 
    startLength = 37;
    
    static 
    const 
    int 
    endLength = 30;
    
public:
    /**
     *  In case of too long input name replaces middle part by "...". 
     */
    static 
    QString shortCutRegionName(const QString & orignal);
    /**
     *  In case of too long input name replaces middle part by "...". 
     */
    static 
    std::string shortCutRegionName(const std::string & orignal);
};
#endif
