/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef BLADE_WIDGET_H
#define BLADE_WIDGET_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QToolBar>
#include <QComboBox>

#include "TabInterface.h"
#include "Cube.h"

#include "Trace.h"

#include "OverviewTraceWidget.h"
#include "SubTraceWidgetHolder.h"
#include "TraceInfoWidget.h"

#include "Cube.h"


class BladeWidget : public QWidget
{
    Q_OBJECT
    
private:
    
    QToolBar * controls;
    
    CallPathFilter * c_filter;
    FlatFilter * f_filter;
    
    ZoomFilter * z_overview_filter;
    
    std::vector<SubTraceWidgetHolder> subtraces;
    OverviewTraceWidget * overview;
    QComboBox * overview_selector;
    TraceInfoWidget * info_widget;
    
    cube::Cube * cube;
    bool no_callpath;
    bool compact;
    
public slots:
    
    void
    unZoom();
    
    void
    goBack();
    
    void
    moveLeft();
    
    void
    moveRight();
    
    void
    updateCursors( QPointF );
    
    void
    compactToggle();
    
    
    
    void
    info();
    
    void
    updateOverview( int );
    
public:
    BladeWidget(Trace * _trace, cube::Cube*,  QWidget * parent = NULL);
    ~BladeWidget();
    
    void
    selectionChanged( cube::Metric*, bool, 
                      cube::Cnode*, bool,  
                      cube::Sysres*, bool,  
                      cube::Region*, bool );
    
    void
    tabActivated( cubepluginapi::TreeType  type );
    

};


uint64_t location_extractor(SubTraceWidgetHolder _l);

#endif // TESTPLUGIN1_H
