/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef CALL_LEVEL_FILTER_H
#define CALL_LEVEL_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>

#include "TraceEventFilter.h"
#include "TraceEvent.h"

class CallLevelFilter : public TraceEventFilter 
{

private:
    int32_t level;
    
    
public:
    CallLevelFilter();
    
    FilterResult 
    apply( TraceEvent *  );
    
    void
    set_call_level(int32_t _l /* size of widget*/ );

    inline 
    void
    print()
    {
        std::cout << " CL: " <<  level  << std::endl;
    }
    
   
};

#endif // FILTER_H

