/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef COLLECTIVE_TRACE_EVENT_H
#define COLLECTIVE_TRACE_EVENT_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <otf2/otf2.h>
#include"TraceEvent.h"




class CollectiveTraceEvent : public TraceEvent 
{
protected:

    uint64_t communicator;
    
    
public:

    CollectiveTraceEvent( uint64_t _location): TraceEvent( _location) {};
    virtual
    ~CollectiveTraceEvent() {};
    
    
    inline
    void
    init(  uint64_t _c)
    {
       communicator = _c;
    }
    
 
    inline
    uint64_t
    get_communicator() const 
    {
        return communicator;
    }  
    

    
};



#endif // TRACE_EVENT_H

