/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef COLOR_MAP_H
#define COLOR_MAP_H

#include <map>
#include <utility>

#include <otf2/otf2.h>
#include "TraceEvent.h"

#include <QColor>
#include <QPen>
#include <QBrush>


#define NUM_OTF_PARADIGMS 23

class ColorPalette 
{
private:
    std::map< OTF2_Paradigm, std::pair< QPen, QBrush> > palette; 
    std::map<OTF2_Paradigm, QColor> color_combinations;
    
    static
    const
    OTF2_Paradigm   otf2_paradigms[ NUM_OTF_PARADIGMS ];// 22 -number of otf2 paradigms....
 
 
    void
    initialize();
    
    void
    defineColors();
    

    std::pair<QPen, QBrush>
    getColorCombination( QColor );

public:

    ColorPalette();
    

    
    
    std::pair<QPen, QBrush>
    getColoring( const TraceEvent *);
};


#endif // TESTPLUGIN1_H
