/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __CONSTANT_EVALUATION_H
#define __CONSTANT_EVALUATION_H 0

#include "NullaryEvaluation.h"

// namespace cube
// {
class ConstantEvaluation : public NullaryEvaluation
{
protected:
    double constant;

public:
    ConstantEvaluation( double _const );
    ~ConstantEvaluation();

    inline
    virtual
    TraceEventStrippedSection
    eval( TraceEventSection& _input)
    {
        TraceEventStrippedSection _s = _input.get_stripped_section( constant );
        return _s;
    };

    virtual
    void
    print()
    {
        std::cout << constant;
    };

};
// };

#endif
