/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __DELTA_EVALUATION_H
#define __DELTA_EVALUATION_H 0

#include "UnaryEvaluation.h"

// namespace cube
// {
class DeltaEvaluation : public UnaryEvaluation
{
public:
    DeltaEvaluation();
    DeltaEvaluation( GeneralEvaluation* _arg ) : UnaryEvaluation( _arg )
    {
    };
    virtual
    ~DeltaEvaluation();

    inline
    virtual
    TraceEventStrippedSection
    eval( TraceEventSection& _input)
    {
        TraceEventStrippedSection _s = argument->eval(_input);
        double _v = _s.end_value - _s.start_value ;
        _s.end_value = _v;
        _s.start_value =_v;
        return _s;
    };



    virtual
    void
    print()
    {
        std::cout << "delta( ";
        argument->print();
        std::cout << ")";
    };


};
// };

#endif
