/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __DIRECT_METRIC_EVALUATION_H
#define __DIRECT_METRIC_EVALUATION_H 0

#include "NullaryEvaluation.h"



// namespace cube
// {
// enum  MetricReferenceType { CONTEXT_METRIC = 0, FIXED_METRIC_NO_AGGR, FIXED_METRIC_AGGR_SYS, FIXED_METRIC_FULL_AGGR, METRIC_CALL_FULL, METRIC_CALL_CALLPATH };


class DirectMetricEvaluation : public NullaryEvaluation
{
private:
    std::string            metric_uniq_name;
    size_t index;


public:
    DirectMetricEvaluation( std::string _name);

    ~DirectMetricEvaluation();

    inline
    virtual
    TraceEventStrippedSection
    eval( TraceEventSection& _input);

    virtual
    void
    print()
    {
        std::cout << "metric::";
        std::cout << metric_uniq_name << "()";
     };

};
// };
#endif
