/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __DRIVER_H
#define __DRIVER_H 0

#include <vector>
#include <iostream>
#include <float.h>
#include <cmath>


#include "GeneralEvaluation.h"




namespace bladeparser
{
class Driver
{
protected:
    std::vector<std::string > errors;
protected:
public:

    Driver(  ) ;
    virtual
    ~Driver();

    virtual
    GeneralEvaluation*
    compile( std::         istream*,
             std::ostream* errs );

    virtual
    bool
    test( std::string&,
          std::string& );

    virtual
    std::string
    printStatus();
};
};

#endif
