/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef FLAT_FILTER_H
#define FLAT_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>

#include "TraceEventFilter.h"

class FlatFilter : public TraceEventFilter 
{
protected:
    uint64_t region;
    bool exclusive;
public:
    FlatFilter() { exclusive = false; };
    
    
    void
    set_region( uint64_t, bool _is_expanded = false);
    
    inline
    bool
    is_exclusive()
    {
        return exclusive;
    };
    
    FilterResult 
    apply( TraceEvent *  );
    
        inline 
    void
    print()
    {
        std::cout << " F: "  << std::endl;
    }
    
    
};

#endif // FILTER_H

