/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __FORWARD_EVALUATION_H
#define __FORWARD_EVALUATION_H 0

#include "UnaryEvaluation.h"

// namespace cube
// {
class ForwardEvaluation : public UnaryEvaluation
{
public:
    ForwardEvaluation();
    ForwardEvaluation( GeneralEvaluation* _arg ) : UnaryEvaluation( _arg )
    {
    };
    virtual
    ~ForwardEvaluation();

    inline
    virtual
    TraceEventStrippedSection
    eval( TraceEventSection& _input)
    {
        TraceEventStrippedSection _s = argument->eval(_input);
        _s.end_value = _s.start_value;
        return _s;
    };


    virtual
    void
    print()
    {
        std::cout << "forward( ";
        argument->print();
        std::cout << ")";
    };


};
// };

#endif
