/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef LOAD_TRACE_WIDGET_H
#define LOAD_TRACE_WIDGET_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QToolBar>
#include <QTimer>
#include <QThread>
#include "Cube.h"

#include "TraceLoaderThread.h"
#include "Trace.h"
#include "TraceInfoWidget.h"


class LoadTraceWidget : public QWidget
{
    Q_OBJECT
    
private:
    QString path;
    QProgressBar * loading_progress;
    QLabel * loading_message;
    QTimer * timer;
    QVBoxLayout* my_layout;
    
    TraceInfoWidget * trace_info_widget;
    TraceLoaderThread * trace_loader_thread;

    cube::Cube* cube;
    Trace * trace;
    
    int progress;
    
public slots:
    
    void
    load();
    
    Trace*
    getTrace()
    {
        return trace;
    }
    
    void
    loadFinished();
    
    void
    updateProgress();
    
signals:    
    
    void
    traceLoaded();
    
    
protected:
    

    
    
public:
    LoadTraceWidget(QString _path, cube::Cube*, QWidget * parent = NULL);
    ~LoadTraceWidget();
      


};

#endif // TESTPLUGIN1_H
