/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef LOCATION_FILTER_H
#define LOCATION_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>

#include "TraceEventFilter.h"

class LocationFilter : public TraceEventFilter 
{
protected:
    uint64_t location;
    
public:
    LocationFilter(uint64_t _location) { location = _location; };
    
    inline
    void
    set_location( uint64_t _location)
    {
        location = _location;
        emit filterChanged(); 
    }
    
    
    FilterResult 
    apply( TraceEvent *  );
    
    inline 
    void
    print()
    {
        std::cout << " L: " <<  location << std::endl;
    }
    
    
};

#endif // FILTER_H

