/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __MAX_EVALUATION_H
#define __MAX_EVALUATION_H 0

#include "BinaryEvaluation.h"
// namespace cube
// {
class MaxEvaluation : public BinaryEvaluation
{
public:
    MaxEvaluation();
    MaxEvaluation(GeneralEvaluation*,
                  GeneralEvaluation*  ) ;

    virtual
    ~MaxEvaluation();

    inline
    virtual
    TraceEventStrippedSection
    eval( TraceEventSection& _input)
    {
        TraceEventStrippedSection _s1 = argument1->eval(_input);
        TraceEventStrippedSection _s2 = argument2->eval(_input);
        _s1.start_value = std::max(_s1.start_value, _s2.start_value);
        _s1.end_value = std::max(_s1.end_value, _s2.end_value);
        return _s1;
    };

    
    virtual
    void
    print()
    {
        std::cout << "max( ";
        argument1->print();
        std::cout << ", ";
        argument2->print();
        std::cout << ")";
    };

};
// };

#endif
