/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef MOUSE_LABEL_H
#define MOUSE_LABEL_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QToolBar>
#include <QTimer>
#include <QThread>

#include "TraceEvent.h"
#include "TraceEventGroupAnalyzer.h"

class MouseLabel : public QLabel
{
    Q_OBJECT
private:
    TraceEventGroupAnalyzer* an;
signals:

    void
    mouseOver(TraceEventGroupAnalyzer*);
    
protected:
    void 
    mouseMoveEvent ( QMouseEvent * event );
    
public:

    MouseLabel( TraceEventGroupAnalyzer* _an, const QString & text, QWidget * parent = 0, Qt::WindowFlags f = 0);

    

};

#endif // TRACE_EVENT_GROUP_WIDGET_H
