/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef REGION_PROPERTIES_FILTER_H
#define REGION_PROPERTIES_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>
#include <stack>
#include <utility>

#include <QPointF>

#include "TraceEventFilter.h"

class RegionPropertiesFilter : public TraceEventFilter 
{
private:
    std::string name; // currently only name
    
public:
    RegionPropertiesFilter();
    
    virtual
    ~RegionPropertiesFilter();
      
    inline 
    void
    print()
    {
        std::cout << " RP: " <<  name  << std::endl;
    }

    void
    set_name( const std::string & );
    
    virtual
    FilterResult 
    apply( TraceEvent *  );
    
};

#endif // FILTER_H

