/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef REQUEST_P2P_TRACE_EVENT_H
#define REQUEST_P2P_TRACE_EVENT_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <otf2/otf2.h>
#include "P2PTraceEvent.h"





class RequestP2PTraceEvent  : public P2PTraceEvent 
{
protected:
 
    uint64_t request;
    
public:

    RequestP2PTraceEvent( uint64_t _location): P2PTraceEvent( _location)  {};
    virtual
    ~RequestP2PTraceEvent() {};
    
  
    
    inline
    void
    set_request(uint64_t _r)  
    {
        request = _r;
    }
      
    
    inline
    uint64_t
    get_request() const 
    {
        return request;
    }
    
    inline
    bool
    match_request( RequestP2PTraceEvent * _r) const
    {
	if ( _r == NULL)
	    return false;
        return (request == _r->get_request());
            
    }
    
    
};



#endif // TRACE_EVENT_H

