/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef RESOLUTION_FILTER_H
#define RESOLUTION_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>

#include "TraceEventFilter.h"
#include "TraceEvent.h"

class ResolutionFilter : public TraceEventFilter 
{

private:
    uint64_t avail_timestamps;
    uint64_t avail_pixels;
    uint64_t min_resolution;
    
    
public:
    ResolutionFilter();
    
    FilterResult 
    apply( TraceEvent *  );
    
    bool 
    resolved( TraceEvent *, TraceEvent *  );
       
    void
    set_available_pixels(uint64_t _p /* size of widget*/ );
    
    void
    set_available_timestamps( uint64_t _w /* size of timestamp zoom*/ );

    void
    calculate_resolution();
    
    inline 
    void
    print()
    {
        std::cout << " R: " <<  avail_timestamps << ":" << avail_pixels << "=" << min_resolution << std::endl;
    }
    
   
};

#endif // FILTER_H

