/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef ROLE_FILTER_H
#define ROLE_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>
#include <stack>
#include <utility>

#include <QPointF>

#include "TraceEventFilter.h"

class RoleFilter : public TraceEventFilter 
{
private:
    bool collective;
    bool p2p;
    bool others;
    
public:
    RoleFilter();
    
    virtual
    ~RoleFilter();
      
    inline 
    void
    print()
    {
        std::cout << " R: " <<  (collective?"collective":"") << "," << (p2p?"point-to-point":"") << std::endl;
    }

    void
    set_collective( bool );
    
    void
    set_point2point( bool );
    
    void
    set_others( bool );   
    
    virtual
    FilterResult 
    apply( TraceEvent *  );
    
};

#endif // FILTER_H

