/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef SELECTION_FILTER_H
#define SELECTION_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>

#include "TraceEventFilter.h"

#include "Cube.h"

class SelectionFilter : public TraceEventFilter 
{
protected:
    cube::Metric * metric;
    cube::CalculationFlavour state;
    cube::Cube * cube;
    
    
public:
    SelectionFilter( cube::Cube* _c):cube(_c) 
    {  
        metric = NULL;
        state = cube::CUBE_CALCULATE_EXCLUSIVE;
    };
    
    inline
    void
    set_metric( cube::Metric* _m, cube::CalculationFlavour _mf)
    {
        metric = _m;
        state = _mf;
    }
    
    FilterResult 
    apply( TraceEvent *  );
    
        inline 
    void
    print()
    {
        std::cout << " Sel: "  << std::endl;
    }
    
    
};

#endif // FILTER_H

