/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_CONTROL_H
#define TRACE_CONTROL_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QToolBar>
#include <QAction>

#include "MetricTraceWidget.h"


class TraceControl : public QToolBar
{
    Q_OBJECT
private:
    std::vector<QWidget *> widgets;
    std::vector<QWidget *> metrics_to_hide;
    bool hidden;
    bool metrics_hidden;
    
    QAction * hideToggle;
    QAction * hideMetrics;
    
    
public slots:
    
    void 
    toggleHiding();
    
    void 
    toggleMetrics();
    
    bool
    isHidden()
    { 
	return hidden;
    }
    
    
public:
    TraceControl(QWidget * parent = NULL);
    ~TraceControl();
    
    void 
    addWidgetToHide(QWidget *);

    void 
    addMetricsToHide(QWidget *);
    
    
};


#endif // TESTPLUGIN1_H
