/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_EVENT_GROUP_ANALYZER_H
#define TRACE_EVENT_GROUP_ANALYZER_H

#include <map>
#include <utility>
#include <vector>
#include <string>
#include "TraceEvent.h"
#include "TraceEventRect.h"

class TraceEventGroupAnalyzer
{
protected:
    std::string name;
    std::string description;    
    
    
    uint64_t group_min;
    uint64_t group_max;
    
    std::vector<int> location_line_index;
    std::vector< TraceEventRect *> rects;
    std::vector< QGraphicsSimpleTextItem *> permanent_labels;
    std::vector< QGraphicsSimpleTextItem *> dynamic_labels;

    
    void
    clear_analyzer();
    
public:

    
~TraceEventGroupAnalyzer();
  
    
    
bool
probe(std::vector< TraceEvent*>& events);

void
analyze(std::vector< TraceEvent*>& events, int, int );

uint64_t 
get_group_min() const
{
    return group_min;
}

uint64_t 
get_group_max() const
{
    return group_max;
}

std::string &
getName()
{
    return name;
};

std::string&
getDescription()
{
    return description;
};

std::vector< TraceEventRect * > &
get_rects()
{
    return rects;
}

std::vector< QGraphicsSimpleTextItem * > &
get_permanent_labels()
{
    return permanent_labels;
}

std::vector< QGraphicsSimpleTextItem * > &
get_dynamic_labels()
{
    return dynamic_labels;
}
  
};


#endif // TESTPLUGIN1_H
