/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_EVENT_GROUP_COLLECTION_H
#define TRACE_EVENT_GROUP_COLLECTION_H

#include <vector>

#include "Service.h"
#include "TraceEventGroup.h"



template<class T>
class TraceEventGroupCollection 
{
protected:
    std::vector<T*> groups;
    std::string progress_message;
    
public:
    TraceEventGroupCollection() {  progress_message = ""; }; 
    
    virtual
    ~TraceEventGroupCollection() 
    {
        for ( typename std::vector<T*>::iterator iter = groups.begin(); iter != groups.end(); ++iter)
        {
            delete (*iter);
        }
    };
    
    
    inline 
    virtual
    T*  add_event( TraceEvent * _e, uint64_t _l) = 0;
    
    
    inline
    virtual
    double
    get_progress(bladeservices::TraceLoadingProgressStep progress_step)
    {
        return 0.;
    }
    
    inline
    virtual
    std::string&
    get_progress_message()
    {
        return progress_message;
    }   
};


#endif // TRACE_EVENT_GROUP_COLLECTION_H
