/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_EVENT_RECT_H
#define TRACE_EVENT_RECT_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>
#include <stack>
#include <utility>

#include <QGraphicsRectItem>

#include "Trace.h"
#include "TraceEvent.h"

class TraceEventRect : public QGraphicsRectItem 
{
protected:
    
    TraceEvent * te;
    const Trace * trace;
    
    bool original;
    
    uint64_t modified_duration;
    
public:
    TraceEventRect(const Trace *, TraceEvent *,  const QRectF & rect, QGraphicsItem * parent = 0);
    TraceEventRect(uint64_t _duration, const Trace *, TraceEvent *,  const QRectF & rect, QGraphicsItem * parent = 0);
    
    QString
    getRegionName();
    
    QString
    getCallPath();
    
    QString
    getStartTime();
    
    QString 
    getDuration();
    
    QString 
    getMetrics(); // salopp
    
    
    TraceEvent *
    getTraceEvent();
    
};

#endif // FILTER_H

