/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_EVENT_SECTION_H
#define TRACE_EVENT_SECTION_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>
#include <stack>
#include <utility>


#include "TraceEventPoint.h"
class TraceEventStrippedSection;




class TraceEventSection 
{
protected:
    
    TraceEventPoint start;
    TraceEventPoint end;
    

    
public:
    TraceEventSection();
    
    void
    set_start_point( const TraceEventPoint& _s);

    void
    set_end_point( const TraceEventPoint& _e);
    
    inline
    TraceEventPoint&
    get_start_point( )     
    {
        return start;
    }

    inline
    TraceEventPoint&
    get_end_point( ) 
    {
        return end;
    }
    
    
    TraceEventStrippedSection
    get_stripped_section( size_t);
    
    TraceEventStrippedSection
    get_stripped_section(double value);

    
    bool
    intersects(  uint64_t,uint64_t);
    
    
    friend
    std::ostream&
    operator<<( std::ostream&, TraceEventSection& );
    
    
    
    
};




#endif // FILTER_H

