/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_INFO_WIDGET_H
#define TRACE_INFO_WIDGET_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QTextEdit>
#include "LoadFiltersWidget.h"
#include "Trace.h"
#include "TraceLoadEnterFilter.h"
#include "TraceLoadLeaveFilter.h"

class TraceInfoWidget : public QWidget
{
    Q_OBJECT
    
private:

    Trace * trace;
    QTextEdit * general_info;
    QTextEdit * clock_info;
    QTextEdit * regions_info;
    QTextEdit * calltree_info;
    QTextEdit * locations_info;
    QTextEdit * metrics_info;
    LoadFiltersWidget * load_filters;
    QGraphicsView * plugin_logo;
    QGraphicsScene * logo_scene;
    
    
signals:
    void
    loadTrace();
    
public slots:
    void
    startLoadingTrace();
    
    
public:
    TraceInfoWidget(Trace * _trace,  QWidget * _parent = NULL);
    ~TraceInfoWidget() {};
 
    TraceLoadEnterFilter *
    get_load_enter_filter();

    TraceLoadLeaveFilter *
    get_load_leave_filter();
    
    bool
    do_grouping() const;  
    
};

#endif // TESTPLUGIN1_H
