/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_LOAD_ENTER_FILTER_H
#define TRACE_LOAD_ENTER_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>

#include "TraceEventFilter.h"
#include "ZoomEnterFilter.h"
#include "CallLevelFilter.h"
#include "RegionPropertiesFilter.h"
#include "RoleFilter.h"


class TraceLoadEnterFilter : public TraceEventFilter 
{
protected:
    ZoomEnterFilter * zoom_enter_filter;
    CallLevelFilter * calllevel_filter;
    RoleFilter * role_filter;
//     ParadigmFilter * paradigm_filter;
    RegionPropertiesFilter * name_filter;
    
public:
    TraceLoadEnterFilter() ;
    ~TraceLoadEnterFilter();
    
    
    FilterResult 
    apply( TraceEvent *  );
    
    void
    init( uint64_t, uint64_t, int32_t/*, std::string&, std::string*/);
    
    
    inline 
    void
    print()
    {
        std::cout << " LoadTrace (Enter) >>> "  << std::endl;
	zoom_enter_filter->print();
	calllevel_filter->print();
        std::cout << " <<< LoadTrace (Enter) "  << std::endl;
	
    }
    
    
};

#endif // FILTER_H

