/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_LOAD_LEAVE_FILTER_H
#define TRACE_LOAD_LEAVE_FILTER_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>

#include "TraceEventFilter.h"
#include "ZoomLeaveFilter.h"
#include "ResolutionFilter.h"

class TraceLoadLeaveFilter : public TraceEventFilter 
{
protected:
    ZoomLeaveFilter * zoom_leave_filter;
    ResolutionFilter * resolution_filter;
    
public:
    TraceLoadLeaveFilter() ;
    ~TraceLoadLeaveFilter();
    
    
    FilterResult 
    apply( TraceEvent *  );
    
    void
    init(uint64_t, uint64_t,  uint64_t);
    
    
    inline 
    void
    print()
    {
        std::cout << " LoadTrace (Leave) >>> "  << std::endl;
	zoom_leave_filter->print();
	resolution_filter->print();
        std::cout << " <<< LoadTrace (Leave) "  << std::endl;
	
    }
    
    
};

#endif // FILTER_H

