/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TRACE_LOADER_THREAD_H
#define TRACE_LOADER_THREAD_H

#include <QThread>
#include <QString>

#include "Trace.h"
#include "TraceLoader.h"
#include "Cube.h"


class TraceLoadEnterFilter;
class TraceLoadLeaveFilter;

class TraceLoaderThread : public  QThread
{
    Q_OBJECT
    
private:
    TraceLoadEnterFilter * trace_load_enter_filter;
    TraceLoadLeaveFilter * trace_load_leave_filter;
    bool                grouping;
    TraceLoader * trace_loader ;
    Trace * trace;
    QString path;
    cube::Cube * cube;
    
public slots:
    
    
    Trace*
    getTrace()
    {
        return trace;
    }
    
signals:
    void
    traceLoaded();
    
    
protected:
    virtual
    void
    run();
    
    
public:
    TraceLoaderThread(QString _path, cube::Cube*);
    ~TraceLoaderThread();
      
    double
    get_progress();
    std::string&
    get_progress_message();
    
    void
    set_load_filters( TraceLoadEnterFilter *, TraceLoadLeaveFilter *, const bool);
    
};

#endif // TESTPLUGIN1_H
