/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef WAIT_TRACE_EVENT_H
#define WAIT_TRACE_EVENT_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <otf2/otf2.h>
#include "RequestP2PTraceEvent.h"




class WaitTraceEvent : public RequestP2PTraceEvent 
{
    
protected:
    RequestP2PTraceEvent*  accomplished_event;
    
public:

    WaitTraceEvent( uint64_t _location): RequestP2PTraceEvent(  _location)
    { 
        accomplished_event = NULL;
    };
    
    virtual
    ~WaitTraceEvent() {};
    
    
    inline
    void
    init( uint64_t _t, uint64_t _p2p_partner, uint64_t _c, uint64_t _r)
    {
        set_request( _r );
        this->P2PTraceEvent::init( _t, _p2p_partner, _c );
    }
    
    inline 
    bool
    match( IRecvP2PTraceEvent * _p ) 
    {
        if (_p == NULL)
	    return false;
        if (  this->P2PTraceEvent::match( _p ) && match_request( _p ))
        {
            return true;
        }
        return false;
    } 
        
    inline
    void
    set_completed_req_events( AsyncP2PTraceEvent* _e)
    {
       accomplished_event =  _e ; 
    }
};



#endif // TRACE_EVENT_H

