/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef WAITALL_TRACE_EVENT_H
#define WAITALL_TRACE_EVENT_H

#include <string>
#include <vector>
#include <inttypes.h>
#include <otf2/otf2.h>
#include "RequestP2PTraceEvent.h"



class WaitallTraceEvent : public RequestP2PTraceEvent 
{
protected:
    std::vector<RequestP2PTraceEvent*> accomplished_events;
    bool added;

public:

    WaitallTraceEvent( uint64_t _location):   RequestP2PTraceEvent(_location)
    { 
        added =false;
    };
    
    virtual
    ~WaitallTraceEvent() {};
    
       
    inline
    void
    init( uint64_t _t, uint64_t _p2p_partner, uint64_t _c, uint64_t _r)
    {    
        set_request( _r );
        this->P2PTraceEvent::init( _t, _p2p_partner, _c );
    }
 
    inline 
    bool
    match( IRecvP2PTraceEvent * _p ) 
    {
	if (_p == NULL)
	    return false;
        if (  this->P2PTraceEvent::match( _p ) && match_request( _p ))
        {
            com_partner= _p;
            return true;
        }
        return false;
    } 
    
    
    inline
    void
    add_completed_req_events( AsyncP2PTraceEvent* _e)
    {
       accomplished_events.push_back( _e ); 
    }
    
    inline
    std::vector<RequestP2PTraceEvent*>&
    get_completed_req_events( )
    {
       return accomplished_events; 
    }    
    
    inline
    void
    set_added() 
    {
        added = true;
    }
    
    
    inline 
    bool
    is_added() const
    {
        return added;
    }
    
    
};



#endif // TRACE_EVENT_H

